@echo off

rem DD.BAT - Disk Distribution
rem     24-Feb-92 Bob Lafleur

cls

echo This batch file will allow you to insert a series of disks into a floppy
echo drive. All the disks will be put into ZIP files in one directory, and a
echo batch file will be created to extract these ZIP files back onto
echo diskettes, keeping the directory structure and disk labels intact.
echo 
echo PKZIP must be accessible in your PATH.
echo 

rem Make easy-out batch file
echo @rem >end.bat

rem Get the name of the software.
set package=
GETSET package .\ "Enter the name of the software you are packaging (7 characters max)" /P /U
if errorlevel 1 end
call package
del package.bat
md %package%
cd %package%

if not exist *.* goto nodel
echo Files exist from a previous run for %package%.
askyn -y Ok to delete these files?
if errorlevel 1 end
del *.*

:nodel

rem Make easy-out batch file
echo @rem >end.bat

rem Get the drive where we'll be reading from
set srcdrv=A
echo 
GETSET srcdrv .\ "Enter the drive letter where the original disks will be inserted" /L /U
if errorlevel 1 end
call srcdrv
del srcdrv.bat

set suffix=
set disks=

rem create the initial "variable" part of the extract batch file
echo rem Start extracting the files for %package%. >%package%.t1

:mainloop

set returnto=sfxset
goto make_sfx

:sfxset
rem Get the label, and pack the disk.

echo echo >>%package%.t1
echo echo Label a formatted disk with the following: >>%package%.t1
echo echo  >>%package%.t1

echo 
echo Enter the description on the label of disk %disks%. Press enter on a
echo blank line when done.
echo 

:diskdesc
set lbl=
GETSET lbl .\ " " /P /M
if errorlevel 1 end
call lbl.bat
del lbl.bat
if .%lbl% == . goto donedesc
echo echo       %lbl% >>%package%.t1
goto diskdesc

:donedesc

echo 
echo Insert the disk in drive %srcdrv%.
pause

pkzip -arpex$%srcdrv% %package%%suffix% %srcdrv%:\*.*
if errorlevel 1 end

echo echo >>%package%.t1
echo echo This disk will be erased! Insert it into drive %%drv%%. >>%package%.t1
echo pause >>%package%.t1
echo fcdeldir /b %%drv%%:\*.* >>%package%.t1
echo pkunzip -do -$ %package%%suffix% %%drv%%:\ >>%package%.t1
echo if errorlevel 1 goto end >>%package%.t1
echo 
askyn -y Do you have another disk to process?
if errorlevel 1 goto nomore
goto mainloop

:nomore
echo echo >>%package%.t1
echo echo The set of %disks% %package% %disk% was successfully created. >>%package%.t1
echo echo >>%package%.t1
echo :end >>%package%.t1

if .%disks% == .1 set disk=disk
if not .%disks% == .1 set disk=disks

rem Create the "top" of the extract batch file.
echo @echo off >%package%.t2
echo cls >>%package%.t2
echo echo This procedure will make the distribution %disk% for %package%. >>%package%.t2
echo echo You will need %disks% formatted %disk%. >>%package%.t2
echo askyn -y Ok to continue? >>%package%.t2
echo if errorlevel 1 end >>%package%.t2
echo echo >>%package%.t2

echo set drv=A >>%package%.t2
echo GETSET drv .\ "Enter the drive letter where the %disk% will be created" /L /U >>%package%.t2
echo if errorlevel 1 end >>%package%.t2
echo call drv >>%package%.t2
echo del drv.bat >>%package%.t2

copy %package%.t2+%package%.t1 %package%.bat >NUL
del %package%.t1
del %package%.t2

cls

echo All %disks% %disk% have been successfully packaged.
echo 
echo 

rem remove easy-out batch file
del end.bat

rem go back to the "home" directory.
cd ..

:end
end

:make_sfx
rem make the next "suffix" for ZIP files.

if .%suffix% == .G set disks=8
if .%suffix% == .G set suffix=H
if .%suffix% == .H goto %returnto%

if .%suffix% == .F set disks=7
if .%suffix% == .F set suffix=G
if .%suffix% == .G goto %returnto%

if .%suffix% == .E set disks=6
if .%suffix% == .E set suffix=F
if .%suffix% == .F goto %returnto%

if .%suffix% == .D set disks=5
if .%suffix% == .D set suffix=E
if .%suffix% == .E goto %returnto%

if .%suffix% == .C set disks=4
if .%suffix% == .C set suffix=D
if .%suffix% == .D goto %returnto%

if .%suffix% == .B set disks=3
if .%suffix% == .B set suffix=C
if .%suffix% == .C goto %returnto%

if .%suffix% == .A set disks=2
if .%suffix% == .A set suffix=B
if .%suffix% == .B goto %returnto%

if .%suffix% == . set disks=1
if .%suffix% == . set suffix=A
if .%suffix% == .A goto %returnto%

