@echo off
REM SAMPLE.BAT for GETSET sample usage.
rem     16-Mar-93 rdl
cls
echo This sample shows how GETSET can be used to select files from a
echo directory, or automatically select ONE file if there is only one
echo file to select.
echo 

set dirname=C:\DOS\*.TXT

if exist DIRNAME.BAT call DIRNAME

rem Now let's let them enter what they might REALLY want.
GETSET DIRNAME .\ "Please enter the wildcard selection" /P /U
if errorlevel 1 goto SKIP_IT

rem ReSET variable value in case it was changed.
call dirname
if .%dirname% == . goto skip_it

rem Now we'll see if there's any files in the directory they entered.
set filespec=`F%dirname%

rem Have GETSET do the lookup for us...
GETSET FILESPEC .\ "" /B
call filespec
del filespec.bat
if .%filespec% == . goto no_files
if .%filespec% == .* goto many_files
goto list_it

:no_files
rem No files to list
echo There are no files matching your wildcard specification.
goto quit

:many_files
rem Many files, let them select one from directory.
dir %dirname%
set filespec=
GETSET FILESPEC .\ "Please enter a filename to list" /P /U
call filespec
del filespec.bat
if errorlevel 1 goto skip_it
if .%filespec% == . goto skip_it
rem Put the original path and their filename together
set dirpath=`p%dirname%
GETSET DIRPATH .\ "" /B
call dirpath
set filespec=%dirpath%%filespec%
set dirpath=
del dirpath.bat

:list_it
Rem actually list the file!
echo %filespec% will be listed if you have LIST in your path.
pause
list %filespec%
goto quit

:SKIP_IT
echo You quitter!

:QUIT
rem Delete the env_var from the environment space if no longer needed
SET dirname=
SET filespec=
